/* Flat Lists by Struct and Pointer */
#define	NULL	0
struct cell
 { ListElementType hd;  /* the `head' or data in the Cell */
   struct cell *tl;     /* the `tail' or rest of the List */
 };

typedef struct cell Cell;
typedef Cell *List;


/* Function prototypes */
List cons(ListElementType, List);
void freeList(List L);
List reverse(List L);
List accumulateAndReverse(List inL, List opL);
List reverseSlow(List L);
List append(List L1, List L2);
int lengthItr(List L);
int length(List L);
List map(ListElementType f(ListElementType), List L);
List merge(List A, List B);
int null(List L);  /*predicate*/ 
ListElementType head(List L);
List tail(List L);
List range(int lo, int hi);
void reverseSE(/*var*/ List *L);
List range(int,int);
List filterMultiples(int P, List L);
List sieve(List L);
List primes(int N);
List mergeSort(List);
List splitAndMerge(List inL, List half1, List half2);
void WriteList(List L);



/* Flat Lists by Struct and Pointer */
